<template>
  <v-dialog v-model="dialogDelete" max-width="500px">
    <v-card>
      <v-card-title class="headline"
        >Are you sure you want to delete this item?</v-card-title
      >
      <v-card-actions>
        <v-spacer></v-spacer>
        <v-btn color="blue darken-1" text @click="closeDelete">Cancel</v-btn>
        <v-btn color="blue darken-1" text @click="deleteItemConfirm">OK</v-btn>
        <v-spacer></v-spacer>
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>

<script>
import { mapState, mapActions } from "vuex";
export default {
  name: "DeleteItem",
  data() {
    return {
      defaultItem: {
        id: "",
        name: "",
        status: "",
        species: "",
        type: "",
        genter: "",
        origin: "",
        location: "",
      },
    };
  },
  computed: {
    ...mapState({
      editedIndex: (state) => state.editedIndex,
      dialogDeleteState: (state) => state.dialog.dialogDelete,
    }),
    dialogDelete: {
      get() {
        return this.dialogDeleteState;
      },
      set(value) {
        return this.SET_DIALOG({ key: "dialogDelete", value });
      },
    },
  },
  methods: {
    ...mapActions([
      "SET_EDITED_ITEM",
      "SET_EDITED_INDEX",
      "MODIFY_USERS",
      "SET_DIALOG",
    ]),
    deleteItemConfirm() {
      this.MODIFY_USERS({ operation: "splice", value: this.editedIndex });
      this.closeDelete();
    },
    closeDelete() {
      this.SET_DIALOG({ key: "dialogDelete", value: false });
      this.$nextTick(() => {
        this.SET_EDITED_ITEM(Object.assign({}, this.defaultItem));
        this.SET_EDITED_INDEX(-1);
      });
    },
  },

  watch: {
    dialogDelete(val) {
      val || this.closeDelete();
    },
  },
};
</script>

<style>
</style>